import random
from time import sleep
import requests
import os
from crawl_hero import api

'''
@Contact :   liuyuqi.gov@msn.cn
@Time    :   2022/03/08 21:12:55
@License :   Copyright © 2017-2020 liuyuqi. All Rights Reserved.
@Desc    :   

# 2. 编写一个工具(LOL皮肤下载工具) ----封装的思想
#   给用户展示所有的英雄名称和id (在控制台输出 所有英雄的名称和id  每三个为一行)
#   用户输入想要的英雄皮肤   (用户输入所需要的英雄id)
#   如果有,则进行下载,      判断id是否在英雄id列表中存在
#   如果没有让用户从新输入    y 继续数据皮肤信息    n 输出程序结束
'''

class CrawlHero():

    def __init__(self):
        self.s = requests.Session()
        self.hero_id_list = []

    def getHeroId(self):
        response = self.s.get(api.hero_list_url).json()
        hero_list = response["hero"]
        print("-----------所有英雄id和名字--------------------")
        input("按任意键继续")
        index = 1
        tmp = ""
        for hero in hero_list:
            tmp = tmp + hero["heroId"] + " " + hero["name"] + "    "
            if index % 3 == 0:
                print(tmp)
                tmp = ""
            self.hero_id_list.append(hero["heroId"])
            index = index + 1

    def getHeroPic(self):
        while(1):
            mHeroId = input("用户输入所需要的英雄id(0代表所有):")
            if mHeroId=="0":
                for hero_id in self.hero_id_list:
                    self.downPic(hero_id)
            else:
                # 获取所有英雄图片的地址
                for hero_id in self.hero_id_list:
                    if mHeroId == hero_id:
                        self.downPic(hero_id)
            print("下载结束，头像保存至当前目录\r\n\r\n")
            yn = input("y 继续    n 输出程序结束:")
            if yn == "n":
                exit()

    def downPic(self, hero_id):
        print("开始下载英雄id为%s的皮肤" % hero_id)
        hero_img_url = api.hero_img_url % (hero_id)
        skin_list = self.s.get(hero_img_url).json()["skins"]
        for skin in skin_list:
            sleep(random.uniform(0.1, 2))
            mainImg = skin["mainImg"]
            heroName = skin["heroName"]
            name = skin["name"]
            name = name.replace("/", "").replace("\\", "")
            dataDir= "./data"
            if not os.path.exists(os.path.join(dataDir,heroName)):
                os.makedirs(os.path.join(dataDir,heroName))
            try:
                fileName = os.path.join(dataDir, heroName, name + ".jpg")
                if skin["chromaImg"] != "" or skin["mainImg"] != "":
                    if mainImg == "":
                        with open(fileName, "wb") as file:
                            file.write(self.s.get(
                                                skin["chromaImg"]).content)
                        print("已下载英雄id为 %s 名称为 %s 的皮肤 %s, url: %s" % (hero_id, heroName, name, skin["chromaImg"]))
                    else:
                        with open(fileName, "wb") as file:
                            file.write(self.s.get(skin["mainImg"]).content)
                        print("已下载英雄id为 %s 名称为 %s 的皮肤 %s, url: %s" % (hero_id, heroName, name, skin["mainImg"]))
                else:
                    print("未找到英雄id为 %s 名称为 %s 的皮肤 %s 的图片" % (hero_id, heroName, name))
            except Exception as e:
                print(e)

    def getHero(self):
        self.getHeroId()
        self.getHeroPic()
        self.clean()

    def clean(self):
        """ 清理文件大小小于50kb的 图片 """
        dataDir = "./data"
        for root, dirs, files in os.walk(dataDir):
            for dir in dirs:
                path = os.path.join(root, dir)
                for name in os.listdir(path):
                    if os.path.getsize(os.path.join(path, name)) < 50*1024:
                        os.remove(os.path.join(path, name))
                        print("删除文件%s" % name)